"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDecorator = void 0;

var _prismjs = _interopRequireDefault(require("prismjs"));

require("prismjs/components/prism-abap");

require("prismjs/components/prism-bash");

require("prismjs/components/prism-basic");

require("prismjs/components/prism-c");

require("prismjs/components/prism-clojure");

require("prismjs/components/prism-coffeescript");

require("prismjs/components/prism-cpp");

require("prismjs/components/prism-csharp");

require("prismjs/components/prism-css");

require("prismjs/components/prism-dart");

require("prismjs/components/prism-docker");

require("prismjs/components/prism-elixir");

require("prismjs/components/prism-elm");

require("prismjs/components/prism-erlang");

require("prismjs/components/prism-flow");

require("prismjs/components/prism-fortran");

require("prismjs/components/prism-fsharp");

require("prismjs/components/prism-gherkin");

require("prismjs/components/prism-glsl");

require("prismjs/components/prism-go");

require("prismjs/components/prism-graphql");

require("prismjs/components/prism-groovy");

require("prismjs/components/prism-java");

require("prismjs/components/prism-javascript");

require("prismjs/components/prism-json");

require("prismjs/components/prism-kotlin");

require("prismjs/components/prism-latex");

require("prismjs/components/prism-less");

require("prismjs/components/prism-lisp");

require("prismjs/components/prism-livescript");

require("prismjs/components/prism-makefile");

require("prismjs/components/prism-markdown");

require("prismjs/components/prism-markup");

require("prismjs/components/prism-nix");

require("prismjs/components/prism-objectivec");

require("prismjs/components/prism-ocaml");

require("prismjs/components/prism-pascal");

require("prismjs/components/prism-perl");

require("prismjs/components/prism-php");

require("prismjs/components/prism-powershell");

require("prismjs/components/prism-prolog");

require("prismjs/components/prism-python");

require("prismjs/components/prism-r");

require("prismjs/components/prism-reason");

require("prismjs/components/prism-ruby");

require("prismjs/components/prism-rust");

require("prismjs/components/prism-sass");

require("prismjs/components/prism-scheme");

require("prismjs/components/prism-scss");

require("prismjs/components/prism-sql");

require("prismjs/components/prism-swift");

require("prismjs/components/prism-typescript");

require("prismjs/components/prism-vbnet");

require("prismjs/components/prism-verilog");

require("prismjs/components/prism-vhdl");

require("prismjs/components/prism-visual-basic");

require("prismjs/components/prism-wasm");

require("prismjs/components/prism-xml-doc");

require("prismjs/components/prism-yaml");

var _slate = require("slate");

var _core = require("@sheets-editor/core");

require("prismjs/themes/prism.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const getLength = token => {
  if (typeof token === 'string') {
    return token.length;
  } else if (typeof token.content === 'string') {
    return token.content.length;
  } else {
    return token.content.reduce((l, t) => l + getLength(t), 0);
  }
};

const createDecorator = (editor, type) => ([node, path]) => {
  const ranges = [];

  if (!_slate.Text.isText(node)) {
    return ranges;
  }

  const parent = (0, _core.getBlockAbove)(editor, {
    at: path
  });

  if (!parent || !(0, _core.isNodeType)(parent, {
    allow: [type]
  })) {
    return ranges;
  }

  const language = parent[0].language;

  const tokens = _prismjs.default.tokenize(node.text, _prismjs.default.languages[language]);

  let start = 0;

  for (const token of tokens) {
    const length = getLength(token);
    const end = start + length;

    if (typeof token !== 'string') {
      ranges.push({
        decorateCode: true,
        token: token.type,
        anchor: {
          path,
          offset: start
        },
        focus: {
          path,
          offset: end
        }
      });
    }

    start = end;
  }

  return ranges;
};

exports.createDecorator = createDecorator;
//# sourceMappingURL=createDecorator.js.map